new algorithms and lower bounds for monotonicity testing of boolean functions

Post on 07-Jan-2016

34 Views

Category:

Documents

0 Downloads

Preview:

Click to see full reader

DESCRIPTION

Rocco Servedio Joint work with Xi Chen and Li-Yang Tan Columbia University. New Algorithms and Lower Bounds for Monotonicity Testing of Boolean Functions. Institute for Advanced Study March 2014. Simplest question about a Boolean function: Does it have some property P ?. - PowerPoint PPT Presentation

TRANSCRIPT

New Algorithms and Lower Bounds for Monotonicity Testing of Boolean Functions

Rocco Servedio

Joint work with Xi Chen and Li-Yang TanColumbia University

Institute for Advanced StudyMarch 2014

Property Testing

All Boolean functions

Property P

Query access to unknown f on any input x

With as few queries as possible, decide if

Far from P

Simplest question about a Boolean function: Does it have some property P?

f has Property P vs. f does not have Property P

Unreasonable: Easy lower bound of

f is far from having Property P

Rules of the game

1. If f has Property P, accept w.p. > 2/3.

2. If f is ε-far from having Property P, reject w.p. > 2/3.

3. Otherwise: doesn’t matter what we do.

All Boolean functions

Property P Far from P

Query access to unknown f on any input x

This work: P = monotonicity

Monotone Far from monotone

Well-studied problem:

[GGR98, GGL+98, DGL+99, FLN+02, HK08, BCGM12, RRS+12, BBM12, BRY13, CS13, …]

but still significant gaps in our understanding.

This work: P = monotonicity

Background and prior results

For all monotone functions g: A monotone function is one that satisfies:

Monotone Far from monotone

Quick reminder about monotonicity

“Flipping an input bit from 0 to 1 cannot make f go from 1 to 0”

Monotone

1

01

1

01

Far from monotone

0n 0n

1n 1n

First test that comes to mind

Pick random edge

y = 1 1 1 1 0 0 1 0 1 0 1 0 0 1

x = 1 1 1 1 0 0 1 1 1 0 1 0 0 1

Reject!

f(x) = 0

f(y) = 1

f(x) = 1

f(y) = 1

f(x) = 0

f(y) = 0

f(x) = 1

f(y) = 0

Repeat

?x

y

Call such an edge a “violating edge”

Theorem [Goldreich et al. 1998] If f is ε-far from monotone, Ω(ε/n) fraction of edges are violations.

Therefore tester will reject within O(n/ε) queries.

An observation and a theorem

Reject!

f(x) = 0

f(y) = 1

Call such an edge a “violating edge”

Simple observation: If f is monotone, tester never rejects.

Question: If f is ε-far from monotone, how likely to catch violating edge?

?x

y

Tester = Sample random edges, check for violations.

An exponential gap between upper and lower bounds

Goldreich et al. [FOCS 1998]

Introduced problem, gave tester with O(n) query complexity.

Fischer et al. [STOC 2002]

Any non-adaptive tester must make Ω(log n) queries. Therefore, any adaptive tester must make Ω(log log n) queries.

Chakrabarty-Seshadhri [STOC 2013]

O(n7/8)-query non-adaptive tester!

[GGR98, DGL+99, HK08, BCGM12, RRS+12, BRY13, CS13, …]

Lower bound:

Any non-adaptive tester must make queries.Therefore, any adaptive tester must make queries.

Exponential improvements over Ω(log n) and Ω(log log n) lower bounds of Fischer et al. (2002)

Upper bound:There is a non-adaptive tester that make

queries.

Polynomial improvement over O(n7/8) upper bound of Chakrabarty and Seshadhri (2013)

Our results

Rest of talk

The lower bound

• Main idea of the argument in a simpler setting

• Key technical ingredient: Multidimensional Central LimitTheorems

• Generalizing the lower bound: Testing monotonicity on hypergrids

Yao’s minimax principle

Lower bound against randomized algorithms

Tricky distribution over inputs to deterministic algorithms

implies

Yao’s principle in our setting

Monotone Far from Monotone

Distribution Dno supported on far from monotone functions

Indistinguishability. For all T = deterministic tester that makes o(n1/5) queries,

Distribution Dyes supported

on monotone functions

Dno : = −1 with prob 0.1, 7/3 with prob 0.9

Main Structural Result: Indistinguishability

Any deterministic tester that makes few queries cannot tell Dyes from Dno

Key property: , .

Dyes : = uniform from {1,3}

Our Dyes and Dno distributions

Both supported on Linear Threshold Functions (LTFs) over {−1,1}n:

Verify: Dyes LTFs are monotone, Dno LTFs far from monotone w.h.p.

Claim. For all T = deterministic tester that makes q = o(n1/5) queries,

Indistinguishability: starting small

q = 1 query

Non-trivial proof of a triviality

Claim. Let T = deterministic tester that makes 1 query, on string z. Then:

(*)

vs.

Tester sees:

Central Limit Theorems. Sum of many independent “reasonable” random variables converges to Gaussian of same mean and variance.

Main analytic tool (Baby version):

Goal: Upper bound

Recall key property:

Claim. Let T = deterministic tester that makes 1 query. Then:

We just proved:

Plenty of room to spare!Would be happy with < 0.1

q queries instead of 1

Multidimensional CLTs. Sum of many independent “reasonable” q-dimensional random variables converge to q-dimensional

Gaussian of same mean and variance.

Main analytic tool (Grown-up version):

Multidimensional CLTs

[Mossel 08, Gopalan-O’Donnell-Wu-Zuckerman 10]

Lower bound

[Valiant-Valiant 11]

Main technical work:

Adapting multidimensional CLT for Earth Mover Distance to get

Claim. For all T = deterministic tester that makes q = o(n1/5) queries,

Let’s prove the real thing:

Setting things up

Arrange the q queries of tester T in a q x n matrix Q

i-th query string

Recall: Tester’s goal is to distinguish

versus

What does the tester see?

Goal: Upper bound

Tester sees:

(coordinate-wise sign)

Goal: Upper bound

Random variables supported on 2q orthants of Rq

union of orthants“roughly equal weight on any union of orthants”

Fixed

from product distribution over Rn sum of n independent vectors in Rq

Ditto:

Goal: Two sums of n independent vectors in Rq are “close”

where closeness = roughly equal weight on any union of orthants.

The final setup

Furthermore, since

suffices to show each are close to q-dimensional Gaussian with matching mean and covariance matrix.

Valiant-Valiant Multidimensional CLT

Sum of many independent “reasonable” q-dimensional random variables is close to q-dimensional Gaussian of same mean and variance.

with respect to Earth Mover Distance:

Minimum amount of work necessary to “change one PDF into the other one”,

where work := mass x distance

Technical lemma:Closeness in EMD roughly equal

weight on any union of orthants

Valiant-Valiant Multidimensional CLT

Key technical lemma

Closeness in EMD Roughly equal weight on any union of orthants

Let’s consider the contrapositive:for all unions of orthants

≥ 0.1 unit of mass must be moved out of

Recall: work = mass x distance

Slight technical obstacle: What if this 0.1 unit of mass only moves a tiny distance?

Solution: Then G has ≥ 0.1 weight on red boundary.

Not possible thanks to anti-concentration of G

If we want to make S look like G,

In slightly more detail

For all r > 0, define Br := radius r boundary around

Therefore:

, has to be moved out of

Br

We just proved

Gaussian anti-concentration

Valiant-ValiantCLT

The details

t=O(1) in our setting

= in our setting

Optimal choice of makes RHS

Pick , and RHS is o(1) as desired.

Indistinguishability. For all T = deterministic tester that makes q = o(n1/5) queries,

Recap

Lower bound:

Any non-adaptive tester must make queries.Therefore, any adaptive tester must make queries.

Testing monotonicity of Boolean functions over general hypergrid domains

Boolean functions over hypergrids

Monotone Far from monotone

All Boolean functionsAll Boolean-valued functions over hypergrid

Testing monotonicity of Boolean functions over hypergrids

Lower bound: *Any non-adaptive tester for testing monotonicity of

.must make queries.

* only for even m

Proof by reduction to m=2 case (Boolean hypercube)

A useful characterization

Theorem. [Fischer et al. 2002]

There exists ε .

mn vertex-disjoint pairs such that and .

is ε-far from monotone

“violating pair”

(Upward direction is easy)

0

1

0

1

0

1

0

1

0

1

0

10

1

Given any , define as follows:

Reducing to m = 2

numbers in [m] bits in {0,1}

Easy: If f is monotone then so is F.

Remains to argue:If f is ε-far from monotone then so is F.

Exists ε2n vertex-disjoint pairs in {0,1}n that are violations w.r.t. f

Exists ε .

mn vertex-disjoint pairs in [m]n that are violations w.r.t. F

Useful characterization

Useful characterization

Each violating pair (m/2)n vertex-disjoint violating pairs

suffices to show:

f(x) = 0

f(y) = 1

1

0 S(x)

S(y){0,1}n

[m]n

|S(x)| = |S(y)| = (m/2)n

where

Easy end game: exhibit order-preserving bijection between S(x) and S(y)

Conclusion

A polynomial lower bound for testing monotonicity of Boolean functions

Main technical ingredient: multidimensional central limit theorems Proof extends to testing monotonicity over general hypergrid domains

(when m is even)

Open Problem: Polynomial lower bounds against adaptive testers?

Lower bound:

Any non-adaptive tester must make queries.Therefore, any adaptive tester must make queries.

What I didn’t talk about

An improved one-sided, non-adaptive tester

Builds on ingredients from [Chakrabarty and Seshadhri 2013]: trade off edge tester versus “path tester”

We give a different “path tester” with an improved analysis

Open Problems: can we exploit adaptivity or two-sided error to obtain more efficient testers?

Upper bound:There is a non-adaptive tester that make

queries.

Thank you!

top related